#include <iostream>

struct Base {
  Base()
  : originalValue(3), value(3)
  { }
  Base(int value)
  : originalValue(3), value(value)
  { }
  inline void check() {
    if (value == originalValue)
      std::cout << "Error: still has original value" << std::endl;
    else
      std::cout << "Ok: switched to new value: " << value << std::endl;
  }
private:
  int originalValue;
  int value;
};

struct Original : public Base {
  Original()
  : Base()
  { }
};

struct New : public Base {
  New()
  : Base(5)
  { }
};

struct A {
  A()
  : value()
  {}
  
  void checkValue() { value.check(); }
  
  void checkValue2() { value2.check(); }
private:
  Original value;
  New value2;
};

int main()
{
  A a;
  
  a.checkValue();
  a.checkValue2();
  
  return 0;
}
